import { Controller } from '@hotwired/stimulus';
import { useWindowFocus } from './use-window-focus';
export class WindowFocusComposableController extends Controller {
    constructor() {
        super(...arguments);
        this.hasFocus = false;
    }
}
export class WindowFocusController extends WindowFocusComposableController {
    constructor(context) {
        super(context);
        requestAnimationFrame(() => {
            const [observe, unobserve] = useWindowFocus(this, this.options);
            Object.assign(this, { observe, unobserve });
        });
    }
}
//# sourceMappingURL=window-focus-controller.js.map